Index: src/sans/dataloader/readers/cansas_constants.py
===================================================================
--- src/sans/dataloader/readers/cansas_constants.py	(revision ac5b69d317038c3025e6c4a3397e52b2a3012a79)
+++ src/sans/dataloader/readers/cansas_constants.py	(revision 3241dd2afd3d492743dc8e2ecf2d5ecd2e8b4b99)
@@ -37,5 +37,5 @@
                 if name != "SASentry":
                     return_me.current_level = \
-                            return_me.current_level.get("children").get(name, "")
+                        return_me.current_level.get("children").get(name, "")
                     if return_me.current_level == "":
                         return_me.current_level = \
@@ -44,13 +44,14 @@
                     cl_datatype = return_me.current_level.get("storeas", "")
                     cl_units_optional = \
-                                return_me.current_level.get("units_required", "")
-                    # Where are how to store the variable for the given namespace
-                    # CANSAS_CONSTANTS tree is hierarchical, so is no value, inherit
-                    return_me.ns_variable = cl_variable if cl_variable != "" else \
-                                        return_me.ns_variable
-                    return_me.ns_datatype = cl_datatype if cl_datatype != "" else \
-                                        return_me.ns_datatype
+                             return_me.current_level.get("units_required", "")
+                    # Where are how to store the variable for the given
+                    # namespace CANSAS_CONSTANTS tree is hierarchical, so 
+                    # is no value, inherit
+                    return_me.ns_variable = cl_variable if cl_variable != "" \
+                        else return_me.ns_variable
+                    return_me.ns_datatype = cl_datatype if cl_datatype != "" \
+                        else return_me.ns_datatype
                     return_me.ns_optional = cl_units_optional if \
-                                        cl_units_optional != return_me.ns_optional \
+                        cl_units_optional != return_me.ns_optional \
                                         else return_me.ns_optional
             except AttributeError:
@@ -61,23 +62,28 @@
     
     
-    """
-    CANSAS_NS holds the base namespace and the default schema file information
-    """
+    def get_namespace_map(self):
+        """
+        Helper method to get the names namespace list
+        """
+        return self.names
+    
+    
+    # CANSAS_NS holds the base namespace and default schema file information
     CANSAS_NS = {
-                 "1.0" : {
-                          "ns" : "cansas1d/1.0", 
-                          "schema" : "cansas1d_v1_0.xsd"
-                          },
-                 "1.1" : {
-                          "ns" : "urn:cansas1d:1.1", 
-                          "schema" : "cansas1d_v1_1.xsd"
-                          }
+                 "1.0" : 
+                 {
+                  "ns" : "cansas1d/1.0", 
+                  "schema" : "cansas1d_v1_0.xsd"
+                  },
+                 "1.1" : 
+                 {
+                  "ns" : "urn:cansas1d:1.1", 
+                  "schema" : "cansas1d_v1_1.xsd"
+                  }
                  }
     
     
-    """
-    The constants below hold information on where to store the CanSAS data when
-    loaded in using sasview
-    """
+    # The constants below hold information on where to store the CanSAS data
+    # when loaded in using sasview
     META_DATA = "{0}.meta_data[\"{2}\"] = \"{1}\""
     ANY = {
@@ -89,8 +95,9 @@
     SASPROCESS_TERM = {
                        "variable" : None,
-                       "attributes" : {
-                                       "unit" : {"variable" : None},
-                                       "name" : {"variable" : None}
-                                       }
+                       "attributes" : 
+                       {
+                        "unit" : {"variable" : None},
+                        "name" : {"variable" : None}
+                        }
                        }
     SASPROCESS_SASPROCESSNOTE = {
@@ -103,6 +110,6 @@
                                 "name" : {"variable" : "{0}.name = \'{1}\'"},
                                "date" : {"variable" : "{0}.date = \'{1}\'"},
-                               "description" : {"variable" : \
-                                                "{0}.description = \'{1}\'"},
+                               "description" : 
+                               {"variable" : "{0}.description = \'{1}\'"},
                                "term" : SASPROCESS_TERM,
                                "SASprocessnote" : SASPROCESS_SASPROCESSNOTE,
@@ -112,72 +119,78 @@
     RUN = {
            "variable" : "{0}.run.append(\"{1}\")",
-           "attributes" : {"name" : {"variable" : \
-                                     "{0}.run_name[node_value] = \"{1}\""}}
+           "attributes" : 
+           {"name" : {"variable" : "{0}.run_name[node_value] = \"{1}\""}}
            }
     SASDATA_IDATA_Q = {
                        "variable" : "{0}.x = numpy.append({0}.x, {1})",
                        "unit" : "x_unit",
-                       "attributes" : {
-                                       "unit" : {
-                                                 "variable" : \
-                                                    "{0}._xunit = \"{1}\"",
-                                                    "storeas" : "content"
-                                                    }
-                                       }
+                       "attributes" : 
+                       {
+                        "unit" : 
+                        {
+                         "variable" : "{0}._xunit = \"{1}\"",
+                         "storeas" : "content"
+                         }
+                        },
                        }
     SASDATA_IDATA_I = {
                        "variable" : "{0}.y = numpy.append({0}.y, {1})",
                        "unit" : "y_unit",
-                       "attributes" : {
-                                       "unit" : {
-                                                 "variable" : \
-                                                    "{0}._yunit = \"{1}\"",
-                                                    "storeas" : "content"
-                                                }
-                                       }
+                       "attributes" : 
+                       {
+                        "unit" : 
+                        {
+                         "variable" : "{0}._yunit = \"{1}\"",
+                         "storeas" : "content"
+                         }
+                        },
                        }
     SASDATA_IDATA_IDEV = {
-                          "variable" : \
-                          "{0}.dy = numpy.append({0}.dy, {1})",
+                          "variable" : "{0}.dy = numpy.append({0}.dy, {1})",
                           "unit" : "y_unit",
-                          "attributes" : {
-                                          "unit" : {
-                                                    "variable" : META_DATA,
-                                                    "storeas" : "content"
-                                                    }
-                                          },
+                          "attributes" : 
+                          {
+                           "unit" : 
+                           {
+                            "variable" : META_DATA,
+                            "storeas" : "content"
+                            }
+                           },
                           }
     SASDATA_IDATA_QDEV = {
-                          "variable" : \
-                          "{0}.dx = numpy.append({0}.dx, {1})",
+                          "variable" : "{0}.dx = numpy.append({0}.dx, {1})",
                           "unit" : "x_unit",
-                          "attributes" : {
-                                          "unit" : {
-                                                    "variable" : META_DATA,
-                                                    "storeas" : "content"
-                                                    }
-                                          },
+                          "attributes" : 
+                          {
+                           "unit" : 
+                           {
+                            "variable" : META_DATA,
+                            "storeas" : "content"
+                            }
+                           },
                           }
     SASDATA_IDATA_DQL = {
-                         "variable" : \
-                         "{0}.dxl = numpy.append({0}.dxl, {1})",
+                         "variable" : "{0}.dxl = numpy.append({0}.dxl, {1})",
                          "unit" : "x_unit",
-                         "attributes" : {
-                                         "unit" : {
-                                                   "variable" : META_DATA,
-                                                "storeas" : "content"
-                                                }
-                                         },
+                         "attributes" : 
+                         {
+                          "unit" : 
+                          {
+                           "variable" : META_DATA,
+                           "storeas" : "content"
+                           }
+                          },
                          }
     SASDATA_IDATA_DQW = {
-                         "variable" : \
-                         "{0}.dxw = numpy.append({0}.dxw, {1})",
+                         "variable" : "{0}.dxw = numpy.append({0}.dxw, {1})",
                          "unit" : "x_unit",
-                         "attributes" : {
-                                         "unit" : {
-                                                   "variable" : META_DATA,
-                                                   "storeas" : "content"
-                                                   }
-                                         },
+                         "attributes" : 
+                         {
+                          "unit" : 
+                          {
+                           "variable" : META_DATA,
+                           "storeas" : "content"
+                           }
+                          },
                          }
     SASDATA_IDATA_QMEAN = {
@@ -228,20 +241,25 @@
                                  "variable" : "{0}.wavelength.append({1})",
                                  "unit" : "wavelength_unit",
-                                 "attributes" : {
-                                                 "unit" : {
-                                                            "variable" : "{0}.wavelength_unit = \"{1}\"",
-                                                            "storeas" : "content"
-                                                            }
-                                                 }
+                                 "attributes" : 
+                                 {
+                                  "unit" : 
+                                  {
+                                   "variable" : \
+                                    "{0}.wavelength_unit = \"{1}\"",
+                                   "storeas" : "content"
+                                   }
+                                  }
                                  }
     SASTRANSSPEC_TDATA_T = {
                             "variable" : "{0}.transmission.append({1})",
                             "unit" : "transmission_unit",
-                            "attributes" : {
-                                            "unit" : {
-                                                      "variable" : "{0}.transmission_unit = \"{1}\"",
-                                                      "storeas" : "content"
-                                                      }
-                                            }
+                            "attributes" : 
+                            {
+                             "unit" : 
+                             {
+                              "variable" : "{0}.transmission_unit = \"{1}\"",
+                              "storeas" : "content"
+                              }
+                             }
                             }
     SASTRANSSPEC_TDATA_TDEV = {
@@ -249,10 +267,13 @@
                                     "{0}.transmission_deviation.append({1})",
                                "unit" : "transmission_deviation_unit",
-                                "attributes" : {
-                                                "unit" : {
-                                                          "variable" : "{0}.transmission_deviation_unit = \"{1}\"",
-                                                          "storeas" : "content"
-                                                          }
-                                                }
+                               "attributes" :
+                               {
+                                "unit" :
+                                {
+                                 "variable" : \
+                                    "{0}.transmission_deviation_unit = \"{1}\"",
+                                 "storeas" : "content"
+                                 }
+                                }
                                }
     SASTRANSSPEC_TDATA = {
@@ -272,9 +293,14 @@
                                   "<any>" : ANY,
                                   },
-                    "attributes" : {"name" : {"variable" : \
-                                              "{0}.name = \"{1}\""},
-                                    "timestamp" : {"variable" : \
-                                                   "{0}.timestamp = \"{1}\""},
-                                    }
+                    "attributes" : 
+                    {
+                     "name" :
+                     {
+                      "variable" : "{0}.name = \"{1}\""},
+                      "timestamp" : 
+                      {
+                       "variable" : "{0}.timestamp = \"{1}\""
+                       },
+                     }
                     }
     SASSAMPLE_THICK = {
@@ -282,10 +308,12 @@
                        "unit" : "sample.thickness_unit",
                        "storeas" : "float",
-                       "attributes" : {
-                                       "units" : {
-                                                  "variable" : "{0}.sample.thickness_unit = \"{1}\"",
-                                                  "storeas" : "content"
-                                                  }
-                                       },
+                       "attributes" : 
+                       {
+                        "unit" : 
+                        {
+                         "variable" : "{0}.sample.thickness_unit = \"{1}\"",
+                         "storeas" : "content"
+                         }
+                        },
                        }
     SASSAMPLE_TRANS = {
@@ -297,13 +325,15 @@
                       "unit" : "sample.temperature_unit",
                       "storeas" : "float",
-                      "attributes" : {
-                                      "units" : {
-                                                 "variable" : "{0}.sample.temperature_unit = \"{1}\"",
-                                                 "storeas" : "content"
-                                                 }
-                                      },
+                      "attributes" : 
+                      {
+                       "unit" : 
+                       {
+                        "variable" : "{0}.sample.temperature_unit = \"{1}\"",
+                        "storeas" : "content"
+                        }
+                       },
                       }
     SASSAMPLE_POS_ATTR = {
-                          "units" : {
+                          "unit" : {
                                      "variable" : \
                                         "{0}.sample.position_unit = \"{1}\"",
@@ -338,8 +368,10 @@
                      }
     SASSAMPLE_ORIENT_ATTR = {
-                             "units" : {
-                                        "variable" : "{0}.sample.orientation_unit = \"{1}\"",
-                                        "storeas" : "content"
-                                        }
+                             "unit" : 
+                             {
+                              "variable" : \
+                                    "{0}.sample.orientation_unit = \"{1}\"",
+                              "storeas" : "content"
+                              }
                              }
     SASSAMPLE_ORIENT_ROLL = {
@@ -370,6 +402,6 @@
                         }
     SASSAMPLE = {
-                 "attributes" : {"name" : {\
-                                    "variable" : "{0}.sample.name = \"{1}\""},},
+                 "attributes" : 
+                    {"name" : {"variable" : "{0}.sample.name = \"{1}\""},},
                  "variable" : None,
                  "children" : {
@@ -387,5 +419,5 @@
     SASINSTR_SRC_BEAMSIZE_ATTR = {
                                   "unit" : \
-                                    "{0}.source.beam_size_unit = \"{1}\"",
+                                        "{0}.source.beam_size_unit = \"{1}\"",
                                   "storeas" : "content"
                                   }
@@ -409,6 +441,7 @@
                                }
     SASINSTR_SRC_BEAMSIZE = {
-                             "attributes" : {"name" : {"variable" : \
-                                        "{0}.source.beam_size_name = \"{1}\""}},
+                             "attributes" : 
+                                {"name" : {"variable" : \
+                                    "{0}.source.beam_size_name = \"{1}\""}},
                              "variable" : None,
                              "children" : {
@@ -422,10 +455,12 @@
                        "unit" : "source.wavelength_unit",
                        "storeas" : "float",
-                       "attributes" : {
-                                       "unit" : {
-                                                 "variable" : "{0}.source.wavelength_unit = \"{1}\"",
-                                                 "storeas" : "content"
-                                                 },
-                                       }
+                       "attributes" : 
+                       {
+                        "unit" : 
+                        {
+                         "variable" : "{0}.source.wavelength_unit = \"{1}\"",
+                         "storeas" : "content"
+                         },
+                        }
                        }
     SASINSTR_SRC_WL_MIN = {
@@ -433,10 +468,13 @@
                            "unit" : "source.wavelength_min_unit",
                            "storeas" : "float",
-                           "attributes" : {
-                                           "unit" : {
-                                                     "variable" : "{0}.source.wavelength_min_unit = \"{1}\"",  
-                                                     "storeas" : "content"
-                                                     },
-                                           }
+                           "attributes" : 
+                           {
+                            "unit" : 
+                            {
+                             "variable" : \
+                                "{0}.source.wavelength_min_unit = \"{1}\"",  
+                             "storeas" : "content"
+                             },
+                            }
                            }
     SASINSTR_SRC_WL_MAX = {
@@ -444,10 +482,13 @@
                            "unit" : "source.wavelength_max_unit",
                            "storeas" : "float",
-                           "attributes" : {
-                                           "unit" : {
-                                                     "variable" : "{0}.source.wavelength_max_unit = \"{1}\"",  
-                                                     "storeas" : "content"
-                                                     },
-                                           }
+                           "attributes" : 
+                           {
+                            "unit" : 
+                            {
+                             "variable" : \
+                                "{0}.source.wavelength_max_unit = \"{1}\"",  
+                             "storeas" : "content"
+                             },
+                            }
                            }
     SASINSTR_SRC_WL_SPR = {
@@ -455,10 +496,13 @@
                            "unit" : "source.wavelength_spread_unit",
                            "storeas" : "float",
-                           "attributes" : {
-                                           "unit" : {
-                                                     "variable" : "{0}.source.wavelength_spread_unit = \"{1}\"",  
-                                                     "storeas" : "content"
-                                                     },
-                                           }
+                           "attributes" : 
+                           {
+                            "unit" : 
+                            {
+                             "variable" : \
+                                "{0}.source.wavelength_spread_unit = \"{1}\"",  
+                             "storeas" : "content"
+                             },
+                            }
                            }
     SASINSTR_SRC = {
@@ -503,6 +547,7 @@
                             }
     SASINSTR_COLL_APER_SIZE = {
-                               "attributes" : {"unit" : {"variable" : \
-                                                    "{0}.size_unit = \"{1}\""}},
+                               "attributes" : 
+                               {"unit" : {"variable" : \
+                                            "{0}.size_unit = \"{1}\""}},
                                "children" : {
                                              "storeas" : "float",
@@ -514,8 +559,10 @@
     SASINSTR_COLL_APER_DIST = {
                                "storeas" : "float",
-                               "attributes" : {
-                                               "storeas" : "content",
-                                               "unit" : {"variable" : \
-                                                "{0}.distance_unit = \"{1}\""}},
+                               "attributes" : 
+                               {
+                                "storeas" : "content",
+                                "unit" : {"variable" : \
+                                            "{0}.distance_unit = \"{1}\""}
+                                },
                                "variable" : "{0}.distance = {1}",
                                "unit" : "distance_unit",
@@ -535,31 +582,34 @@
                           }
     SASINSTR_COLL = {
-                     "attributes" : {"name" : {"variable" : \
-                                               "{0}.name = \"{1}\""}},
+                     "attributes" : 
+                     {"name" : {"variable" : "{0}.name = \"{1}\""}},
                      "variable" : None,
-                     "children" : {
-                                   "length" : {
-                                            "variable" : "{0}.length = {1}",
-                                            "unit" : "length_unit",
-                                            "storeas" : "float",
-                                            "attributes" : {
-                                                            "storeas" : \
-                                                                "content",
-                                                            "unit" : {"variable" : "{0}.length_unit = \"{1}\""}
-                                                            },
-                                            },
-                                   "aperture" : SASINSTR_COLL_APER,
-                                   },
+                     "children" : 
+                     {
+                      "length" : 
+                      {
+                       "variable" : "{0}.length = {1}",
+                       "unit" : "length_unit",
+                       "storeas" : "float",
+                       "attributes" : 
+                       {
+                        "storeas" : "content",
+                        "unit" : {"variable" : "{0}.length_unit = \"{1}\""}
+                        },
+                       },
+                      "aperture" : SASINSTR_COLL_APER,
+                      },
                      }
     SASINSTR_DET_SDD = {
                         "variable" : "{0}.distance = {1}",
                         "unit" : "distance_unit",
-                        "attributes" : {
-                                        "unit" : {
-                                                  "variable" : \
-                                                  "{0}.distance_unit = \"{1}\"",
-                                                  "storeas" : "content"
-                                                  }
-                                        },
+                        "attributes" : 
+                        {
+                         "unit" : 
+                         {
+                          "variable" : "{0}.distance_unit = \"{1}\"",
+                          "storeas" : "content"
+                          }
+                         },
                         }
     SASINSTR_DET_OFF_ATTR = {
@@ -622,27 +672,27 @@
                          "variable" : "{0}.beam_center.x = {1}",
                          "unit" : "beam_center_unit",
-                         "attributes" : {
-                                         "unit" : \
-                                            "{0}.beam_center_unit = \"{1}\"",
-                                         "storeas" : "content"
-                                         }
+                         "attributes" : 
+                         {
+                          "unit" : "{0}.beam_center_unit = \"{1}\"",
+                          "storeas" : "content"
+                          }
                          }
     SASINSTR_DET_BC_Y = {
                          "variable" : "{0}.beam_center.y = {1}",
                          "unit" : "beam_center_unit",
-                         "attributes" : {
-                                         "unit" : \
-                                            "{0}.beam_center_unit = \"{1}\"",
-                                         "storeas" : "content"
-                                         }
+                         "attributes" : 
+                         {
+                          "unit" : "{0}.beam_center_unit = \"{1}\"",
+                          "storeas" : "content"
+                          }
                          }
     SASINSTR_DET_BC_Z = {
                          "variable" : "{0}.beam_center.z = {1}",
                          "unit" : "beam_center_unit",
-                         "attributes" : {
-                                         "unit" : \
-                                            "{0}.beam_center_unit = \"{1}\"",
-                                         "storeas" : "content"
-                                         }
+                         "attributes" : 
+                         {
+                          "unit" : "{0}.beam_center_unit = \"{1}\"",
+                          "storeas" : "content"
+                          }
                          }
     SASINSTR_DET_BC = {
@@ -657,27 +707,27 @@
                         "variable" : "{0}.pixel_size.x = {1}",
                         "unit" : "pixel_size_unit",
-                        "attributes" : {
-                                        "unit" : \
-                                            "{0}.pixel_size_unit = \"{1}\"",
-                                        "storeas" : "content"
-                                        }
+                        "attributes" : 
+                        {
+                         "unit" : "{0}.pixel_size_unit = \"{1}\"",
+                         "storeas" : "content"
+                         }
                         }
     SASINSTR_DET_PIXEL_Y = {
                         "variable" : "{0}.pixel_size.y = {1}",
                         "unit" : "pixel_size_unit",
-                        "attributes" : {
-                                        "unit" : \
-                                            "{0}.pixel_size_unit = \"{1}\"",
-                                        "storeas" : "content"
-                                        }
+                        "attributes" : 
+                        {
+                         "unit" : "{0}.pixel_size_unit = \"{1}\"",
+                         "storeas" : "content"
+                         }
                         }
     SASINSTR_DET_PIXEL_Z = {
                         "variable" : "{0}.pixel_size.z = {1}",
                         "unit" : "pixel_size_unit",
-                        "attributes" : {
-                                        "unit" : \
-                                            "{0}.pixel_size_unit = \"{1}\"",
-                                        "storeas" : "content"
-                                        }
+                        "attributes" : 
+                        {
+                         "unit" : "{0}.pixel_size_unit = \"{1}\"",
+                         "storeas" : "content"
+                         }
                         }
     SASINSTR_DET_PIXEL = {
@@ -692,10 +742,12 @@
                          "variable" : "{0}.slit_length = {1}",
                          "unit" : "slit_length_unit",
-                         "attributes" : {
-                                         "unit" : {
-                                                   "variable" : "{0}.slit_length_unit = \"{1}\"",
-                                                   "storeas" : "content"
-                                                   }
-                                         }
+                         "attributes" : 
+                         {
+                          "unit" : 
+                          {
+                           "variable" : "{0}.slit_length_unit = \"{1}\"",
+                           "storeas" : "content"
+                           }
+                          }
                          }
     SASINSTR_DET = {
@@ -703,8 +755,9 @@
                     "variable" : None,
                     "attributes" : {
-                                    "name" : {
-                                              "storeas" : "content",
-                                              "variable" : "{0}.name = \"{1}\"",
-                                              }
+                                    "name" : 
+                                    {
+                                     "storeas" : "content",
+                                     "variable" : "{0}.name = \"{1}\"",
+                                     }
                                     },
                     "children" : {
@@ -723,35 +776,36 @@
     SASINSTR = {
                 "variable" : None,
-                "children" : {
-                              "variable" : None,
-                              "name" : {"variable" : \
-                                            "{0}.instrument = \"{1}\""},
-                              "SASsource" : SASINSTR_SRC,
-                              "SAScollimation" : SASINSTR_COLL,
-                              "SASdetector" : SASINSTR_DET,
-                              },
+                "children" : 
+                {
+                 "variable" : None,
+                 "name" : {"variable" : "{0}.instrument = \"{1}\""},
+                 "SASsource" : SASINSTR_SRC,
+                 "SAScollimation" : SASINSTR_COLL,
+                 "SASdetector" : SASINSTR_DET,
+                 },
                 }
     CANSAS_FORMAT = {
-                     "SASentry" : {
-                                   "units_optional" : True,
-                                   "variable" : None,
-                                   "storeas" : "content",
-                                   "attributes" : {"name" : {"variable" : \
-                                        "{0}.run_name[node_value] = \"{1}\""}},
-                                   "children" : {
-                                                 "Title" : TITLE,
-                                                 "Run" : RUN,
-                                                 "SASdata" : SASDATA,
-                                                 "SAStransmission_spectrum" : \
-                                                    SASTRANSSPEC,
-                                                 "SASsample" : SASSAMPLE,
-                                                 "SASinstrument" : SASINSTR,
-                                                 "SASprocess" : SASPROCESS,
-                                                 "SASnote" : SASNOTE,
-                                                 "<any>" : ANY,
-                                                 }
-                                   }
+                     "SASentry" : 
+                     {
+                      "units_optional" : True,
+                      "variable" : None,
+                      "storeas" : "content",
+                      "attributes" : {"name" : {"variable" : \
+                                    "{0}.run_name[node_value] = \"{1}\""}},
+                      "children" : {
+                                    "Title" : TITLE,
+                                    "Run" : RUN,
+                                    "SASdata" : SASDATA,
+                                    "SAStransmission_spectrum" : SASTRANSSPEC,
+                                    "SASsample" : SASSAMPLE,
+                                    "SASinstrument" : SASINSTR,
+                                    "SASprocess" : SASPROCESS,
+                                    "SASnote" : SASNOTE,
+                                    "<any>" : ANY,
+                                    }
+                      }
                      }
-   
+
+
 class CurrentLevel:
     """
@@ -769,2 +823,20 @@
         self.ns_datatype = "content"
         self.ns_optional = True
+        
+    def get_current_level(self):
+        """
+        Helper method to get the current_level map
+        """
+        return self.current_level
+    
+    def get_data_type(self):
+        """
+        Helper method to get the ns_datatype label
+        """
+        return self.ns_datatype
+    
+    def get_variable(self):
+        """
+        Helper method to get the ns_variable label
+        """
+        return self.ns_variable